#property copyright "Copyright  2007 Jan Dolonen"
#property link      "jandolonen@hotmail.com"

extern double Lots =0.5;
extern int atrDays = 14;
extern string timeGMT = "00:00:00";
extern int tp_divisor = 2;
extern int sl_divisor = 4;
extern int currency_spread = 2;
int atr = 0;
double atrYD = 0;

int ticket1, ticket2, total, cnt;
//
//
//
int start()
  { 
  
     string myTime =TimeToStr(TimeCurrent(),TIME_SECONDS);
 
     if (myTime == timeGMT){      
      closeAll(); // we close open and pending orders
      openNew(); // we open new pending orders         
      } 
  }

// Custom functions

double yesterdayMid()
{
   double ydMid;
   int a = 0;
   a =((iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point)/2;
   ydMid = iHigh(NULL,PERIOD_D1,1) - (a * Point);
   return(ydMid);
}

int calculateATR()
{
   int atrValue;
   
   for(int i=1;i<=atrDays;i++)
          atrValue = atrValue + (iHigh(NULL,PERIOD_D1,i+1)-iLow(NULL,PERIOD_D1,i+1))/Point;
          atrValue = atrValue/atrDays; 
          return(atrValue);
}

void closeAll()
{
   total = OrdersTotal();
   cnt = 0;
   
   if(total>0){
      for (cnt = 0 ; cnt <= total ; cnt++)
      {
         OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()==OP_BUY) //buy orders
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
            if(OrderType()==OP_SELL) // sell orders
               OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
            if(OrderType()>OP_SELL) //pending orders
               OrderDelete(OrderTicket());
      }  
   }
}

void openNew()
{
   atrYD = yesterdayMid();
   atr = calculateATR();
   int tp = atr/2;
   int sl = atr/4;
   
   total=OrdersTotal();
   if(total<1){ // if no orders are open
      // first we make a buy order
      Print("Ask = " + Ask + ", Bid = " + Bid);
      if (atrYD < Ask){ // if yes then a buy limit, else a buy stop
         ticket1=OrderSend(Symbol(),OP_BUYLIMIT,Lots,atrYD,0,atrYD-sl*Point,atrYD+tp*Point,"atr_trader",16384,0,Green);
      }
      else ticket1=OrderSend(Symbol(),OP_BUYSTOP,Lots,atrYD,0,atrYD-sl*Point,atrYD+tp*Point,"atr_trader",16384,0,Green);
      
      Print("Ticket1: " + ticket1);
      if(ticket1>0)
        {
         if(OrderSelect(ticket1,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
        }
      else Print("Error opening BUY order : ",GetLastError()); 
      
      // then we make a sell order
      if (atrYD < Ask){ // if yes then a sell stop, else a sell limit
         ticket2=OrderSend(Symbol(),OP_SELLSTOP,Lots,atrYD-(2*Point),0,atrYD-(currency_spread*Point)+sl*Point,atrYD-tp*Point,"atr_trader",16385,0,Red);
      }
      else ticket2=OrderSend(Symbol(),OP_SELLLIMIT,Lots,atrYD-(2*Point),0,atrYD-(currency_spread*Point)+(sl*Point),atrYD-tp*Point,"atr_trader",16385,0,Red);         
      Print("Ticket2: " + ticket2);
      if(ticket2>0)
        {
         if(OrderSelect(ticket2,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
        }
         else Print("Error opening SELL order : ",GetLastError()); 
   }
}
      

